/*********************************************************
*	Preferences class
*********************************************************/
function prefClass()
{
	//private
	this.getComInt = getComInt;

	//public load
	this.getData = getData;

	//public save
	this.setData = setData;

	//when class loading get comp + interface in variable
	this.oPref = this.getComInt();

	//get pref comp + interface
	function getComInt()
	{
		try
		{
			//get component
			var pref = Components.classes["@mozilla.org/preferences;1"].createInstance();

			if(!pref)
			{
				showError("Can't find Personal pref component.");
			}

			//get get interface with selected component
			pref = pref.QueryInterface(Components.interfaces.nsIPref);
		}
		catch(e)
		{
			showError(e);
			return;
		}
		return pref;
	}

	//save data
	function setData(sType, sName, sValue)
	{
		try
		{
			if(sType == "char")
			{
				this.oPref.SetCharPref(sName, sValue);
			}
			else if(sType == "integer")
			{
				this.oPref.SetIntPref(sName, sValue);
			}
			else if(sType == "bool")
			{
				this.oPref.SetBoolPref(sName, sValue);
			}
		}
		catch(e)
		{
			showError(e);
		}
	}

	//get data
	function getData(sType, sName)
	{
		var returnValue;

		try
		{
			if(sType == "char")
			{
				returnValue = this.oPref.CopyCharPref(sName);
			}
			else if(sType == "integer")
			{
				returnValue = this.oPref.GetIntPref(sName);			
			}
			else if(sType == "bool")
			{
				returnValue = this.oPref.getBoolPref(sName);			
			}
		}
		catch(e)
		{
		}

		return returnValue;
	}
}

//open side bar ?
function doOpenSideBar()
{
	try
	{		
		var mPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);		

		try
		{
			returnValue = mPrefs.getBoolPref("browser.search.opensidebarsearchpanel");			
			return returnValue;
		}
		catch(e2)
		{
			showError(e2);		
		}
	}
	catch(e)
	{
		showError(e);		
	}
	return false;
}

//load local search preferences
function loadLocalSearch()
{
	var localObj = Components.classes["@mozilla.org/find/find_service;1"]
					.getService(Components.interfaces.nsIFindService);

	if(localObj.searchString)
	{
		document.getElementById("txtSearchStr").value 	= localObj.searchString;
	}
	document.getElementById("checkMatchCase").checked 	= localObj.matchCase;
	document.getElementById("checkWrap").checked 		= localObj.wrapFind;
	document.getElementById("checkBackwards").checked 	= localObj.findBackwards;
	document.getElementById("txtSearchStr").focus();
}

//save local search preferences
function saveLocalSearch(sValue, boolCase, boolWrap, boolBackw)
{
	var localObj = Components.classes["@mozilla.org/find/find_service;1"]
					.getService(Components.interfaces.nsIFindService);

	localObj.searchString  = sValue;
	localObj.matchCase     = boolCase;
	localObj.wrapFind      = boolWrap;
	localObj.findBackwards = boolBackw;
}

//save localsearch preferences
function esSaveLocalSettings(esMenuItem)
{
	if(esMenuItem.id)
	{
		var prefStatus = esMenuItem.getAttribute("checked") ? 1 : 0;
		prefObj.setData("integer", "extensions.easysearch." + esMenuItem.id, prefStatus);
	}
}

//load localsearch preferences
function esLoadLocalSettings()
{
	var checkMatchCase 	= prefObj.getData("integer", "extensions.easysearch.checkMatchCase") ? true : false;
	var checkWrap 		= prefObj.getData("integer", "extensions.easysearch.checkWrap") ? true : false;
	var checkBackwards 	= prefObj.getData("integer", "extensions.easysearch.checkBackwards") ? true : false;
	document.getElementById("checkMatchCase").setAttribute("checked", checkMatchCase);
	document.getElementById("checkWrap").setAttribute("checked", checkWrap);
	document.getElementById("checkBackwards").setAttribute("checked", checkBackwards);
}